%count the number of terms for each angle
SHAPETERMS = cell(A+1,1);
for i = 1:N*N
   s = BOXES{i}.shape;
   SHAPETERMS{s} = [SHAPETERMS{s} i];
end

%output results
for i = 1:A+1
[i length(SHAPETERMS{i}) SHAPETERMS{i}];
end

%LEDMAPPING contains the DIG/SEG value for a particular angle
LEDMAPPING = xlsread('ledmap.xlsx', 'one');

%we will store the data into 4 separate matrices, and compute the angles
%based on them appropriately.

%format the data into the appropriate matrix
BMATRICES = cell(1,A+1);
MASK = cell(1,A+1);
for i = 1:A+1
    B = zeros(N,32);    
    tempST = SHAPETERMS{i};
    for j = 1:length(SHAPETERMS{i})
        %[ind jnd] = find(GRIDCORR==tempST(j),1);
        B(tempST(j)) = 1;
    end
    %save binary matrices
    BMATRICES{i} = B;
    %convert B into a 30x4 matrix
    dim = ceil(30/8);
    Bn = cell(N,dim);
    for k = 1:N
        for l = 1:dim
            Bn{k,l} = bin2hex(B(k,1+(l-1)*dim:l*dim));
        end
    end    
    MASK{i} = Bn;
end

%for every angle, we need a logic matrix of 30*4 chars.
%in total we need storage 57.6k, which is ludicrous. 

%question: less memory usage if hardcoded reference to matrix?
%also, this means churning out hard code. LED[1][1] = MAT11[1][1] |
%MAT11[2][2] ... which is simply nasty

%try that out, i suppose.

%still haven't computed angle rotation yet!

%Using a 30x30 grid: we have a total of 60 angles * 4 * 15 * 8 storage
%space for logical tables: 28.8kb

%camera data is stored in a (4 * 15 * 8)*4 = 1.92kb. 


